require "yaml"
module Coloncancerpredict1
  class Engine < ::Rails::Engine
    initializer "coloncancerpredict1" do 
      OrbitApp.registration "Coloncancerpredict1", :type => "ModuleApp" do
        base_url File.expand_path File.dirname(__FILE__)
        taggable "coloncancerpredictfields1s"
        categorizable
        authorizable
        widget_methods ["widget"]
        widget_settings [{"data_count"=>1}]
        set_keyword_contstraints ['coloncancerpredict1Result']
    		frontend_enabled
    		side_bar do
              head_label_i18n 'coloncancerpredict1.coloncancerpredict1', icon_class: "icons-megaphone"
              available_for "users"
              active_for_controllers (['admin/coloncancerpredict1s'])
              head_link_path "admin_coloncancerpredict1s_path"

              context_link 'coloncancerpredict1.coloncancerpredict1',
                                    :link_path=>"admin_coloncancerpredict1s_path" ,
                                    :priority=>1,
                                    :active_for_action=>{'admin/coloncancerpredict1s'=>'index'},
                                    :available_for => 'users'
    		  context_link 'coloncancerpredict1.submitResult',
                                    :link_path=>"admin_coloncancerpredict1s_showSubmit_path" ,
                                    :priority=>1,
                                    :active_for_action=>{'admin/coloncancerpredict1s'=>'show_submit'},
                                    :available_for => 'users'
    		  context_link 'coloncancerpredict1.export_colon_cancer_predict1_tool_records',
                                    :link_path=>"admin_coloncancerpredict1s_export_cancer_tool_record_path" ,
                                    :priority=>1,
                                    :active_for_action=>{'admin/coloncancerpredict1s'=>'export_cancer_tool_record'},
                                    :available_for => 'users'
    		end
      end
    end
  end
end